;;;; "inout.scm"
;;; Copyright (C) 1995, J. Leveling
;;; See the file `COPYING' for terms applying to this program.

; This is a simple example how to redirect input, output and error
; messages into PCS-like text windows.
; (Almost like Aubrey Jaffer's split.scm !)

(require 'winpcs)
(enter-window-mode)
(window-clear console)

; define windows

(define input-window (make-window "input-window" #t))
(define output-window (make-window "output-window" #t))
(define error-window (make-window "error-window" #t))

; set sizes

(window-set-size! input-window 5 78)
(window-set-size! output-window 10 78)
(window-set-size! error-window 4 78)

; set positions

(window-set-position! input-window 1 1)
(window-set-position! output-window 8 1)
(window-set-position! error-window 20 1)

; clear windows

(window-clear input-window)
(window-clear output-window)
(window-clear error-window)

; redirect input, output and errors

(set-current-input-port input-window)
(set-current-output-port output-window)
(set-current-error-port error-window)


(write-line "Note : current-input-port, current-output-port and
current-error-port have been redefined !")
(write-line "To reset ports, call (reset-ports).")

; to reset ports :
(define (reset-ports)
  (set-current-input-port *default-input-port*)
  (set-current-output-port *default-output-port*)
  (set-current-error-port *default-error-port*)
  (exit-window-mode))
